#include <bits/stdc++.h>
using namespace std;

#define TASK "segments"

struct pt {
    int x, y;
    pt() {}
    pt(int x, int y) : x(x), y(y) {}
};

pt operator-(pt const& a, pt const& b) {
    return pt(a.x - b.x, a.y - b.y);
}

int operator*(pt const& a, pt const& b) {
    return a.x * b.y - b.x * a.y;
}

bool inter_1d(int a, int b, int c, int d) {
    if (a > b) swap(a, b);
    if (c > d) swap(c, d);
    return max(a, c) <= min(b, d);
}

bool inter(pt const& a, pt const& b, pt const& c, pt const& d) {
    return inter_1d(a.x, b.x, c.x, d.x)
        && inter_1d(a.y, b.y, c.y, d.y)
        && ((b - a) * (c - a)) * ((b - a) * (d - a)) <= 0
        && ((a - c) * (a - c)) * ((d - c) * (d - b)) <= 0;
}

vector <vector <int> > comps;
vector <vector <int> > g;
vector <char> vis;
vector <char> color;

void dfs(int v) {
    vis[v] = true;
    comps.back().push_back(v);
    for (int eid = 0; eid < (int)g[v].size(); eid++) {
        int to = g[v][eid];
        if (!vis[to]) dfs(to);
    }
}

vector < vector <int> > part;
bool dfs2(int v, int c = 0) {
    vis[v] = true;
    part[c].push_back(v);
    color[v] = c;
    for (int eid = 0; eid < (int)g[v].size(); eid++) {
        int to = g[v][eid];
        if (!vis[to]) {
            if (!dfs2(to, c ^ 1)) return false;
        } else if (vis[to]) {
            if (color[to] == color[v]) return false;
        }
    }
    return true;
}

int main() {
    freopen(TASK ".in", "r", stdin);
    freopen(TASK ".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector <pt> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }

    vector <int> e(2 * n);
    for (int i = 0; i < n; i++) {
        cin >> e[2 * i] >> e[2 * i + 1];
        --e[2 * i];
        --e[2 * i + 1];
    }

    g.resize(2 * n);

    for (int i = 0; i < 2 * n; i++) {
        pt a = p[i / 2];
        pt b = p[e[i]];
        g[i].push_back(i ^ 1);
        for (int j = i + 1; j < 2 * n; j++) {
            if (i == j) continue;
            pt c = p[j / 2];
            pt d = p[e[j]];

            if (inter(a, b, c, d)) {
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    vis.resize(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        if (!vis[i]) {
            comps.push_back(vector <int>());
            dfs(i);
        }
    }

    vector <int> ans(n);
    color.resize(2 * n);
    vis.assign(2 * n, false);
    for (int i = 0; i < (int)comps.size(); i++) {
        vector <int> &comp = comps[i];
        part.assign(2, vector <int>());
        if (!dfs2(comps[i].front())) {
            cout << "NO\n";
            return 0;
        }
        set <int> nodes;
        for (int j = 0; j < (int)comp.size(); j++) {
            nodes.insert(comp[j] / 2);
        }
        vector < vector <int> > has(2, vector <int>(n));
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < (int)part[i].size(); j++) {
                has[i][part[i][j] / 2] = part[i][j] + 1;
            }
        }

        int mn = 0;
        for (set <int>::iterator it = nodes.begin();
             it != nodes.end(); it++) {
            int v = *it;
            while (mn < 2 && !has[mn][v]) ++mn;
            if (mn == 2) {
                cout << "NO\n";
                return 0;
            }
        }

        for (set <int>::iterator it = nodes.begin();
             it != nodes.end(); it++) {
            int e = has[mn][*it] - 1;
            ans[*it] = e % 2 + 1;
        }
    }

    cout << "YES\n";
    for (int i = 0; i < n; i++) {
        cout << ans[i] << "\n";
    }

    return 0;
}
