#include <iostream>
#include <cstdio>
#include <vector>
#include <memory.h>
#include <algorithm>

using namespace std;

typedef long long ll;

const int maxn = 1 << 17;
const int inf = 2e9;

int n;
int a[maxn];
vector<int> e[maxn];
bool alive[maxn];
int cnt[maxn];
long long ans;

int dfs1(int v, int p) {
	cnt[v] = 1;
	for (int i = 0; i < (int)e[v].size(); i++) {
	 	int to = e[v][i];
		if (to == p || !alive[to]) continue;
		cnt[v] += dfs1(to, v);
	}
	return cnt[v];
}

int dfs2(int v, int k) {
	int p = -1;
	while (1) {
		bool f = false;
	 	for (int i = 0; i < (int)e[v].size(); i++) {
 		 	int to = e[v][i];
			if (to == p || !alive[to]) continue;
			if (cnt[to] * 2 >= k) {
				p = v;
			 	v = to;
				f = true;
				break;
			}
		}
		if (!f) return v;
	}
}

int b[maxn];
int cur;
ll f[4][maxn];
// 0 -- cnt
// 1 -- sum maximums
// 2 -- sum len
// 3 -- sum len * maximums

void add(int k, int x, ll y) {
	while (x < cur) {
	 	f[k][x] += y;
		x = x | (x + 1);
	}
}

ll get(int k, int x) {
 	ll res = 0;
	while (x >= 0) {
	 	res += f[k][x];
		x = (x & (x + 1)) - 1;
	}
	return res;
}

ll get(int k, int l, int r) {
	return get(k, r) - get(k, l - 1);
}

void dfs3(int v, int len, int mx, int p) {
 	mx = max(mx, a[v]);
	for (int i = 0; i < (int)e[v].size(); i++) {
	 	int to = e[v][i];
		if (to == p || !alive[to]) continue;
		dfs3(to, len + 1, mx, v);
	}
	b[cur++] = mx;
	//ans += 1LL * len * mx;
}

void dfs4(int v, int len, int mx, int p) {
	mx = max(mx, a[v]);
	for (int i = 0; i < (int)e[v].size(); i++) {
	 	int to = e[v][i];
		if (to == p || !alive[to]) continue;
		dfs4(to, len + 1, mx, v);
	}
	int k = lower_bound(b, b + cur, mx) - b;
	ans += get(2, 0, k - 1) * mx + get(0, 0, k - 1) * len * mx;
	ans += get(1, k, cur - 1) * len + get(3, k, cur - 1);
}

void dfs5(int v, int len, int mx, int p) {
	mx = max(mx, a[v]);
	for (int i = 0; i < (int)e[v].size(); i++) {
	 	int to = e[v][i];
		if (to == p || !alive[to]) continue;
		dfs5(to, len + 1, mx, v);
	}
	int k = lower_bound(b, b + cur, mx) - b;
	add(0, k, 1);
	add(1, k, mx);
	add(2, k, len);
	add(3, k, 1LL * mx * len);
}

int solve(int v) {
 	dfs1(v, -1);
	v = dfs2(v, cnt[v]);
	cur = 0;
	dfs3(v, 1, -inf, -1);
	sort(b, b + cur);
	cur = unique(b, b + cur) - b;

	for (int i = 0; i < cur; i++) {
	 	f[0][i] = f[1][i] = f[2][i] = f[3][i] = 0;
	}
	int k = lower_bound(b, b + cur, a[v]) - b;
	add(0, k, 1);
	add(1, k, a[v]);
	add(2, k, 1);
	add(3, k, 1LL * a[v] * 1);
	ans += a[v];
	for (int i = 0; i < (int)e[v].size(); i++) {
		int to = e[v][i];
		if (!alive[to]) continue;
		dfs4(to, 1, a[v], v);
		dfs5(to, 2, a[v], v);
	}
	alive[v] = 0;
	for (int i = 0; i < (int)e[v].size(); i++) {
		int to = e[v][i];
		if (!alive[to]) continue;
	 	solve(to);
	}

	return 0;
}


void dfs(int v, int len, int mn, int mx, int p) {
	mn = min(mn, a[v]);
	mx = max(mx, a[v]);
 	ans += 1LL * len * (mx - mn);
	for (int i = 0; i < (int)e[v].size(); i++) {
	 	int to = e[v][i];
		if (to == p) continue;
		dfs(to, len + 1, mn, mx, v);
	}
}

ll slowsolve() {
	ans = 0;
	for (int i = 1; i <= n; i++) {
	 	dfs(i, 1, 1e9, -1e9, -1);
	}
	return ans / 2;
}

ll fastsolve() {
	ans = 0;
	memset(alive, 1, sizeof(alive));
	solve(1);
	for (int i = 1; i <= n; i++) a[i] = -a[i];
	memset(alive, 1, sizeof(alive));
	solve(1);
	for (int i = 1; i <= n; i++) a[i] = -a[i];
	return ans;
}

void gen() {
	n = rand() % 100 + 1;
	for (int i = 1; i <= n; i++) {
		a[i] = rand() % (int)1e5;
		e[i].clear();
	}
	for (int i = 2; i <= n; i++) {
		int p = rand() % (i - 1) + 1;
		e[p].push_back(i);
		e[i].push_back(p);
	}
}

void stress(bool f) {
	if (!f) return;
	for (int it = 0;; it++) {
		cerr << it << endl;
		gen();
		ll ans1 = fastsolve();
		ll ans2 = slowsolve();
		if (ans1 != ans2) {
			cout << ans1 << " " << ans2 << endl;
			break;
		}
	}
	exit(0);
}

int main() {
	freopen("tree.in", "r", stdin);
	freopen("tree.out", "w", stdout);

	stress(0);

	cin >> n;
	for (int i = 1; i <= n; i++) cin >> a[i];
	for (int i = 1; i < n; i++) {
	 	int u, v;
		cin >> u >> v;
		e[u].push_back(v);
		e[v].push_back(u);
	}	

	cout << fastsolve() << endl;
	
	return 0;
}